import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A little penguin that wants to get to the other side.
 */
public class Mage extends character
{
    private static final int jumpStrength = 16;
    private int level;
    private int jumped = 0;   // count how often we've jumped
    mageHealth Health =  new mageHealth();

    public Mage()
    {
        level = 1;
    }

    public void act() 
    {
        checkKeys();        
        checkFall();
        checkAnimation();
        checkHit();
        addHealth();
        knockback();
        
        randomknockback = Greenfoot.getRandomNumber(2);
    }

    private void checkKeys()
    {
        if (Greenfoot.isKeyDown("left") && sheilding == false)
        {
            setImage("walking-left.png");
            moveLeft();
            right = false;

            if(!onGround())
            {
                setImage("jumping-left.png");
            }
        }
        else
        {
            if(onGround() && !right)
            {
                setImage("neutral-left.png");
            }
        }

        if (Greenfoot.isKeyDown("right") && sheilding == false)
        {
            setImage("walking-right.png");
            moveRight();
            right = true;

            if(!onGround())
            {
                setImage("jumping-right.png");
            }
        }
        else
        {
            if(onGround() && right)
            {
                setImage("neutral-right.png");
            }

        }

        if (Greenfoot.isKeyDown("up") && sheilding == false)
        {
            if (gotDoubleJump > 0 && ready)
            {
                jump();
                gotDoubleJump = gotDoubleJump - 1;
                if(!onGround())
                {
                    ready = false;
                }
            }
        }
        else
        {
            ready = true;
        }

        if(Greenfoot.isKeyDown("enter") && counter==0 && sheilding == false)
        {
            if(right)
            {
                setImage("basic-attack.png");
                getWorld().addObject(new fireball(),getX()+28,getY()+6);
            }
            else
            {
                setImage("basic-attack-left.png");
                getWorld().addObject(new fireballLeft(),getX()-32,getY()+6);
            }

            counter = 1;
        }
        else if (Greenfoot.isKeyDown("enter") && sheilding == false){
            counter = 1;

            if(right)
            {
                setImage("basic-attack.png");
            }
            else
            {
                setImage("basic-attack-left.png");
            }
        }
        else
        {
            counter=0;
        }

        if(Greenfoot.isKeyDown("backspace") && upcounter==0 && sheilding == false)
        {
            if(right)
            {
                setImage("MageUpAttackRight.png");
                getWorld().addObject(new fireballDown(),getX(),0);
                getWorld().addObject(new fireballDown(),getX()-38,0);
                getWorld().addObject(new fireballDown(),getX()+38,0);
            }
            else
            {
                setImage("MageUpAttackLeft.png");
                getWorld().addObject(new fireballDown(),getX(),0);
                getWorld().addObject(new fireballDown(),getX()-38,0);
                getWorld().addObject(new fireballDown(),getX()+38,0);
            }

            upcounter = 1;
        }
        else if (Greenfoot.isKeyDown("backspace") && sheilding == false){
            upcounter = 1;

            if(right)
            {
                setImage("MageUpAttackRight.png");
            }
            else
            {
                setImage("MageUpAttackLeft.png");
            }
        }
        else
        {
            upcounter=0;
        }

        if(Greenfoot.isKeyDown("down")||Greenfoot.isKeyDown("5"))
        {
            if(right)
            {
                getWorld().addObject(new MageSheild(), getX()+6, getY()+3);
            }
            else
            {
                getWorld().addObject(new MageSheild(), getX()-5, getY()+3);
            }
            sheilding = true;
        }
        else
        {
            sheilding = false;
        }
    }    

    private void jump()
    {
        setVSpeed(-jumpStrength);
        fall();
        jumped++;
    }

    private void checkFall()
    {
        if (onGround()) {
            setVSpeed(0);
            gotDoubleJump = 2;
        }
        else {
            fall();
        }

        if(atBottom())
        {
            getWorld().addObject(new NinjaWins(),565,270);
            Greenfoot.delay(100);
            Greenfoot.setWorld(new Stage1());
        }
    }

    public void checkAnimation()
    {
        String key = Greenfoot.getKey();
        if(key=="right")
        {
            setImage("neutral-right.png");
        }

        if(key=="left")
        {
            setImage("neutral-left.png");
        }
    }

    public void checkHit()
    {
        Actor SwordHitBox;

        SwordHitBox = getOneObjectAtOffset(0,0,swordHitBox.class);

        if (SwordHitBox != null  && !sheilding)
        {
            Health.damage(4);

            knockback = 14;
        }

        Actor SwordHitBoxLeft;

        SwordHitBoxLeft = getOneObjectAtOffset(0,0,swordHitBoxLeft.class);

        if (SwordHitBoxLeft != null  && !sheilding)
        {
            Health.damage(4);

            knockbackLeft = 14;
        }

        Actor Fireball;

        Fireball = getOneObjectAtOffset(0,0,fireball.class);

        if (Fireball != null  && !sheilding)
        {
            Health.damage(3);
            knockbackLeft = 13;
        }

        Actor FireballLeft;

        FireballLeft = getOneObjectAtOffset(0,0,fireballLeft.class);

        if (FireballLeft != null  && !sheilding)
        {
            Health.damage(3);
            knockback = 13;
        }
        
        Actor FireballDown;

        FireballDown = getOneObjectAtOffset(0,0,fireballDown.class);

        if (FireballDown != null  && !sheilding)
        {
            Health.damage(2);

            if(randomknockback == 1)
            {
                knockbackLeft = 13;
            }
            
            if(randomknockback == 0)
            {
                knockback = 13;
            }
        }
        
        Actor spinningRight;

        spinningRight = getOneObjectAtOffset(0,0,spinningSwordHitBox.class);

        if (spinningRight != null  && !sheilding)
        {
            Health.damage(1);

            knockback = 14;
        }
        
                Actor spinningLeft;

        spinningLeft = getOneObjectAtOffset(0,0,spinningSwordHitBoxLeft.class);

        if (spinningLeft != null  && !sheilding)
        {
            Health.damage(1);

            knockbackLeft = 14;
        }
    }

    public void addHealth(){
        if(wait == 1)
        {
            getWorld().addObject(Health,1030,111);
            wait = 3;
        }
        else if(wait == 0)
        {
            wait = 1;
        }
    }

    public void knockback()
    {
        if(knockback > 0)
        {
            setLocation(getX()+8,getY()-16);
            knockback = knockback - 1;
        }

        if(knockbackLeft > 0)
        {
            setLocation(getX()-8,getY()-16);
            knockbackLeft = knockbackLeft - 1;
        }
    }

    public int wait = 0;

    public boolean right;

    private int counter =0;

    private int upcounter =0;

    public int gotDoubleJump;

    public int knockback;

    public int knockbackLeft;

    public boolean sheilding = false;
    
    public int randomknockback;
    
    public boolean ready = true;
}
