import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A little penguin that wants to get to the other side.
 */
public class Ninja extends character
{
    private static final int jumpStrength = 18;
    private int level;
    private int jumped = 0; 
    // count how often we've jumped
    ninjaHealth health =  new ninjaHealth();

    spinningSwordHitBox spinning =  new spinningSwordHitBox();

    spinningSwordHitBoxLeft spinningLeft =  new spinningSwordHitBoxLeft();

    public Ninja()
    {

    }

    public void act() 
    {
        checkKeys();        
        checkFall();
        checkAnimation();
        checkHit();
        addHealth();
        checkOffGroundForOneJumpOnly();
        knockback();

        randomknockback = Greenfoot.getRandomNumber(2);

    }

    private void checkKeys()
    {
        if (Greenfoot.isKeyDown("a") && sheilding == false)
        {
            
                setImage("ninja-walking-left.png");
                moveLeftForNinja();
                isRight = false;
            

            if(!onGround())
            {
                setImage("ninja-jumping-left.png");
            }
        }
        else
        {
            if(onGround() && !isRight)
            {
                setImage("ninja-neutral-left.png");
            }
        }

        if (Greenfoot.isKeyDown("d") && sheilding == false)
        {
            
                setImage("ninja-walking-right.png");
                moveRightForNinja();
                isRight = true;
            

            if(!onGround())
            {
                setImage("ninja-jumping-right.png");
            }
        }
        else
        {
            if(onGround() && isRight)
            {
                setImage("ninja-neutral-right.png");
            }

        }

        if(Greenfoot.isKeyDown("v") && sheilding == false)
        {
            if(isRight && timer > 0 && offGroundForOneJumpOnly)
            {
                setImage("ninja-stab-right.png");
                getWorld().addObject(new swordHitBox(),getX()+25,getY()+6);
                if(timer > 4)
                {
                    setLocation(getX()+20,getY());
                }
                else
                {
                    setLocation(getX()-20,getY());
                }
                timer = timer - 1;
            }
            else if (timer > 0 && offGroundForOneJumpOnly)
            {
                setImage("ninja-stab-left.png");
                getWorld().addObject(new swordHitBoxLeft(),getX()-25,getY()+6);
                if(timer > 4)
                {
                    setLocation(getX()-20,getY());
                }
                else
                {
                    setLocation(getX()+20,getY());
                }
                timer = timer - 1;
            }

            if(timer == 0)
            {
                offGroundForOneJumpOnly = false;
            }
        }

        else if(timer != 8)
        {
            offGroundForOneJumpOnly = false;
            timer = 8;
        }

        if (Greenfoot.isKeyDown("w") && sheilding == false)
        {
            if (gotDoubleJump > 0 && ready)
            {
                jump();
                gotDoubleJump = gotDoubleJump - 1;
                if(!onGroundForNinja())
                {
                    ready = false;
                }
            }
        }
        else
        {
            ready = true;
        }

        if(Greenfoot.isKeyDown("s"))
        {
            getWorld().addObject(new NinjaSheild(), getX(), getY()+3);

            sheilding = true;
        }
        else
        {
            sheilding = false;
        }

        if(Greenfoot.isKeyDown("b") && sheilding == false)
        {
            if(isRight)
            {
                setImage("spin-attack-right.png");
                getWorld().addObject(spinning,getX(),getY());
                spinning.setRotation(getRotation());
                setRotation(getRotation()+24);
                spinning.setLocation(getX(),getY());
                getWorld().removeObject(spinningLeft);
            }
            else
            {
                setImage("spin-attack-left.png");
                getWorld().addObject(spinningLeft,getX(),getY());
                setRotation(getRotation()-24);
                spinningLeft.setRotation(getRotation());
                spinningLeft.setLocation(getX(),getY());
                getWorld().removeObject(spinning);
            }
        }
        else
        {
            setRotation(0);
            getWorld().removeObject(spinning);
            getWorld().removeObject(spinningLeft);
        }
    }

    private void jump()
    {
        setVSpeed(-jumpStrength);
        fall();
        jumped++;
    }

    private void checkFall()
    {
        if (onGroundForNinja()) {
            setVSpeed(0);
            gotDoubleJump = 2;
        }
        else {
            fall();
        }

        if(atBottom())
        {
            getWorld().addObject(new MageWins(),560,270);
            Greenfoot.delay(100);
            Greenfoot.setWorld(new Stage1());
        }
    }

    public void checkAnimation()
    {
        String key = Greenfoot.getKey();
        if(key=="right")
        {
            setImage("ninja-neutral-right.png");
        }

        if(key=="left")
        {
            setImage("ninja-neutral-left.png");
        }
    }

    public void checkHit()
    {
        Actor Fireball;

        Fireball = getOneObjectAtOffset(0,0,fireball.class);

        if (Fireball != null && !sheilding)
        {
            health.damage(2);
            knockback = 13;
        }

        Actor FireballLeft;

        FireballLeft = getOneObjectAtOffset(0,0,fireballLeft.class);

        if (FireballLeft != null  && !sheilding)
        {
            health.damage(2);
            knockbackLeft = 13;
        }

        Actor FireballDown;

        FireballDown = getOneObjectAtOffset(0,0,fireballDown.class);

        if (FireballDown != null  && !sheilding)
        {
            health.damage(2);

            if(randomknockback == 1)
            {
                knockbackLeft = 13;
            }

            if(randomknockback == 0)
            {
                knockback = 13;
            }
        }

    }

    public void knockback()
    {
        if(knockback > 0)
        {
            setLocation(getX()+14,getY()-12);
            knockback = knockback - 1;
        }

        if(knockbackLeft > 0)
        {
            setLocation(getX()-14,getY()-12);
            knockbackLeft = knockbackLeft - 1;
        }
    }

    public void addHealth(){
        if(wait == 1)
        {
            getWorld().addObject(health,95,111);
            wait = 3;
        }
        else if(wait == 0)
        {
            wait = 1;
        }
    }

    public void checkOffGroundForOneJumpOnly()
    {
        if(onGround())
        {
            offGroundForOneJumpOnly = true;
        }
    }

    public int wait = 0;

    public boolean isRight = true;

    public boolean inGround = true;

    private int counter =0;

    private int timer = 8;

    public boolean offGroundForOneJumpOnly;

    public boolean spacedBefore;

    public int gotDoubleJump;

    public int knockback = 0;

    public int knockbackLeft = 0;

    public boolean sheilding = false;

    public int randomknockback;

    public boolean ready = true;
}
